import os
os.environ['DJANGO_SETTINGS_MODULE'] = "metastate.settings"
#import metastate
import sys
sys.path.append("/home/wizard23/metasense")

from metastate.activity.models import *
import time
from datetime import datetime, timedelta
from pychart import *
from time_offset import time_correct

def get_seconds(dt):
    return time.mktime(dt.timetuple())

def format_date(t):
    return "/a10{}"+datetime.fromtimestamp(t).strftime('%H:%M')

def day_plot(dbName, niceName, fileName, ytic=20, yrange=None):
	now = datetime.now()
	yesterday = now-timedelta(days=1)
	dbLoc = Location.objects.get(description=dbName)
	recentActivities = Activity.objects.filter(timestamp__gte=yesterday, location=dbLoc.id).order_by('timestamp')

	#dirty time bug fix
	now += time_correct
	yesterday += time_correct

	plotData = []
	for a in recentActivities:
		plotData.append((get_seconds(a.timestamp+time_correct), a.activity))

	print "Plotting %d data points" % len(plotData)

	dateFormat = '%Y.%m.%d %H:%M'
	xlabel = "%s: %s - %s" % (niceName, yesterday.strftime(dateFormat), now.strftime(dateFormat))
	xaxis = axis.X(label=xlabel, tic_interval=3600, format=format_date)
	yaxis = axis.Y(label="Nerd Activity", tic_interval = ytic)
	ar = area.T(size=(800, 80), legend=None, x_axis=xaxis, y_axis=yaxis, y_range=(0, yrange), x_range=(get_seconds(yesterday), get_seconds(now)))
	plot = bar_plot.T(label=None, data=plotData)#, ycol=1)
	ar.add_plot(plot)
	can = canvas.init("/var/www/kybernet.org/wizard23/metasense/%s" % fileName, "png")
	ar.draw(can)
	can.close()
	
def day_mini_plot(dbName, niceName, fileName, ytic=20, yrange=None):
	now = datetime.now()
	yesterday = now-timedelta(days=1)
	dbLoc = Location.objects.get(description=dbName)
	recentActivities = Activity.objects.filter(timestamp__gte=yesterday, location=dbLoc.id).order_by('timestamp')

	#dirty time bug fix
	now += time_correct
	yesterday += time_correct

	plotData = []
	for a in recentActivities:
		plotData.append((get_seconds(a.timestamp+time_correct), a.activity))

	print "Plotting %d data points" % len(plotData)

	dateFormat = '%Y.%m.%d %H:%M'
	xlabel = "%s: %s - %s" % (niceName, yesterday.strftime(dateFormat), now.strftime(dateFormat))
	xaxis = axis.X(label=None, tic_interval=3600, format=format_date)
	yaxis = axis.Y(label="Nerd Activity", tic_interval = ytic)
	ar = area.T(size=(800, 60), legend=None, x_axis=xaxis, y_axis=yaxis, y_range=(0, yrange), x_range=(get_seconds(yesterday), get_seconds(now)))
	plot = bar_plot.T(label=None, data=plotData)#, ycol=1)
	ar.add_plot(plot)
	can = canvas.init("/var/www/kybernet.org/wizard23/metasense/%s" % fileName, "png")
	ar.draw(can)
	can.close()
	
day_plot("mainroom_move1", "Main Room Movement", "metalab_activity.png", yrange=100)
day_plot("door_lock", "Lock Status", "metalab_lock_activity.png", 128)
day_plot("kitchen_move", "Kitchen Movement", "metalab_kitchen_activity.png", yrange=100)

day_mini_plot("mainroom_move1", "Main Room Movement", "metalab_activity_mini.png", ytic=25, yrange=100)

    
    
